package jp.ac.osaka_u.ist.sel.clonedetector;


import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import jp.ac.osaka_u.ist.sel.clonedetector.analyze.CAnalyzer;
import jp.ac.osaka_u.ist.sel.clonedetector.analyze.JavaAnalyzer;
import jp.ac.osaka_u.ist.sel.clonedetector.analyze.JavaAnalyzer2;
import jp.ac.osaka_u.ist.sel.clonedetector.data.CloneSet;
import jp.ac.osaka_u.ist.sel.clonedetector.data.Method;
import jp.ac.osaka_u.ist.sel.clonedetector.data.ClonePair;
import jp.ac.osaka_u.ist.sel.clonedetector.evaluate.Comparator;
import jp.ac.osaka_u.ist.sel.clonedetector.evaluate.Debug;
import jp.ac.osaka_u.ist.sel.clonedetector.evaluate.Evaluator;

public class CloneDetector {

	public static final String TARGET = "test";
	public static final String PARAM_FILE = "dataset.txt.params";
	public static final String DATASET_FILE = "dataset.txt";
	public static final String LSH_FILE = "lsh_result.txt";	
	public static final String RESULT_FILE = "result.txt";
	public static final String RESULT_CSV= "result.csv";

	
	public static ArrayList<Method> methodList = new ArrayList<Method>();
	public static final Map<String,Integer> wordMap = new HashMap<String,Integer>();	

	
	/**
	 * <p>C<p>
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {		
		
		long start = System.currentTimeMillis();
		
		//\ؐ
		System.out.println("Aalyze source code ...");
		CAnalyzer analyzer = new CAnalyzer();
		//JavaAnalyzer analyzer = new JavaAnalyzer();
 		analyzer.searchFile(new File(TARGET));			
 		
 		System.out.println(System.currentTimeMillis()-start);
 		
 		//xNgvZ
 		System.out.println("Calculate vector of each method ...");
 		VectorCalculator calculator = new VectorCalculator();
 		methodList = calculator.filterMethod();
 		calculator.calculateVector();
 		
 		System.out.println(System.currentTimeMillis()-start);
 		
 		//LSHNX^O
 		System.out.println("Cluster vector of eah method ...");
 		LSHController.computeParam();
 		LSHController.execute();
 		ArrayList<ClonePair> clonePairList = LSHController.getClonePairList();
 		
 		
 		System.out.println(System.currentTimeMillis()-start);
 		
 		
 		
 		//t@Co
 		ArrayList<CloneSet> cloneSetList = LSHController.getCloneSetList(clonePairList); 		
 		Outputter.outputCloneSetTXTforCPP(cloneSetList);
 		//Outputter.outputCloneSetCSVforCPP(cloneSetList);
 		//Outputter.outputCSVforCPP(clonePairList);
 		//Outputter.outputTXTforCPP(clonePairList); 
 		//Outputter.outputCSVforJava(clonePairList); 
 		//Outputter.outputTXTforJava(clonePairList); 
 	
 		//]
 		//Comparator.compareMeCC(cloneSetList);
 		//Evaluator.evaluate();
 		//Debug.debug();
 		//Debug.outputResult02(cloneSetList);
 		//Debug.outputResult(cloneSetList);
	}
	
	
}
