package jp.ac.osaka_u.ist.sel.y_yuuki.cn.analyze;

import jp.ac.osaka_u.ist.sel.y_yuuki.cn.Def;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.Logger;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Project;

/**
 * <p>\[XR[h̓NX</p>
 * @author y-yuuki
 */
public class AnalyzeManager {

	/**
	 * <p>Oc[𗘗pāCN[擾</p>
	 * @param project ProjectIuWFNg
	 * @return <ul>
	 *           <li>̏ꍇ - true</li>
	 *           <li>s̏ꍇ - false</li>
	 *         </ul>
	 */
	public static boolean getCloneInf(Project project) {

		// ec[̎s
		if(project.getTool().equals(Def.CCFX_TOOLNAME)) {
			CCFXController controller = new CCFXController(project);

			// CCFinderX̎s
			if(!controller.execute()) {
				Logger.writeln("Can't execute CCFinder.", Logger.ERROR);
				return false;
			}

			// oʂ̓Ǎ
			if(!controller.readCloneDataFile()) {
				Logger.writeln("Can't read clone data file.", Logger.ERROR);
				return false;
			}

			try {
				// Ot@C̓Ǎ
				if(!controller.readPrepFile()) {
					Logger.writeln("Can't read preprocess files.", Logger.ERROR);
					return false;
				}
			} catch (Exception e) {
				Logger.writeln("<Exception> Can't read preprocess files.", Logger.ERROR);
				return false;
			}

			// gNX̓Ǎ
			if(!controller.getCloneMetrics()) {
				Logger.writeln("Can't read clone metrics file.", Logger.ERROR);
				return false;
			}
		} else if(project.getTool().equals(Def.CD_TOOLNAME)) {
			CloneDetectorController controller = new CloneDetectorController(project);

			// CloneDetector ̎s
			if(!controller.execute()) {
				Logger.writeln("Can't execute clonedetector.", Logger.ERROR);
				return false;
			}

			// oʂ̓Ǎ
			if(!controller.readCloneDataFile()) {
				Logger.writeln("Can't read clone data file.", Logger.ERROR);
				return false;
			}
		} else {
			Logger.writeln("Can't execute unknown tool '" + project.getTool() + "'.", Logger.FATAL);
			return false;
		}
		return true;
	}



	/**
	 * <p>N[Zbg/N[ύX𕪗ނ</p>
	 * @param project vWFNgIuWFNg
	 * @return <ul>
	 *           <li>̏ꍇ - true</li>
	 *           <li>s̏ꍇ - false</li>
	 *         </ul>
	 */
	public static boolean categorizeClone(Project project) {

		if(!DiffDetector.getDiff(project.getFileList())) {
			Logger.writeln("Can't get diff of source code.", Logger.ERROR);
			return false;
		}

		CloneCategorizer.categorizeClone(project.getFileList());
		CloneSetCategorizer.categorizeClone(project.getCloneSetList(), project);

		return true;
	}
}
