package jp.ac.osaka_u.ist.sel.y_yuuki.cn.analyze;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.Iterator;

import jp.ac.osaka_u.ist.sel.m_sano.extractor.CMethodExtractor;
import jp.ac.osaka_u.ist.sel.m_sano.extractor.JavaMethodExtractor;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.Def;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.Logger;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Clone;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.CloneSet;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Method;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Project;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.SourceFile;
import jp.ac.osaka_u.ist.sel.y_yuuki.visitor.CFileVistor;
import jp.ac.osaka_u.ist.sel.y_yuuki.visitor.JavaFileVistor;

/**
 * <p>Clone Detector ̃Rg[NX</p>
 * @author m-sano
 */
public class CloneDetectorController {

	/** oΏۂ̃vWFNg */
	private Project project = null;

	/**
	 * <p>RXgN^</p>
	 * @param project Project IuWFNg
	 */
	public CloneDetectorController(Project project) {
		this.project = project;
	}

	/**
	 * <p>Clone Detector s</p>
	 * @return <ul>
	 *           <li>̏ꍇ - true</li>
	 *           <li>s̏ꍇ - false</li>
	 *         </ul>
	 */
	public boolean execute() {

		//st@ĈfBNg
		//JgfBNgɂȂƐɓ삵Ȃ
		File dir = new File(Def.CLDT_DIR);

		// Clone Detector spR}h (Vo[W)
		String[] cmdArray1= {
			"java", "-jar",
			Def.CLDT_FILENAME, "-d", project.getNewDir()+"\\src",
			"-l", project.getLang(),
			"-oc", "..\\" + Def.RESULT_CSV,
			"-ot", "..\\" + Def.RESULT_TXT
		};

		// Clone Detector spR}h (o[W)

		// o[WfBNg΃pXɕϊ
		File odir = new File(project.getOldDir());
		String abstOldPath = odir.getAbsolutePath();

		String[] cmdArray2= {
				"java", "-jar",
				Def.CLDT_FILENAME, "-d", abstOldPath+"\\src",
				"-l", project.getLang(),
				"-oc", "..\\" + Def.RESULT_CSV_OLD,
				"-ot", "..\\" + Def.RESULT_TXT_OLD
			};

		ProcessBuilder pb1 = new ProcessBuilder(cmdArray1);
		pb1.directory(dir);
		ProcessBuilder pb2 = new ProcessBuilder(cmdArray2);
		pb2.directory(dir);

		// clonedetectordataset.txt̏ꏊwłȂ
		// ͑SvZXLɂȂ邽, ss\

		// TODO  pb.redirectErrorStream(true) ȂƂ܂Ȃ
		// XXX mǂwaitFor() ȂĂsČ炱Ă񂾂Ǝv, ꉞ.
		try {
			Process pr1 = pb1.start();

			Logger.writeln("Extract new code clone.", Logger.SYSTEM);
			Logger.printlnConsole("Extract new code clone.", Logger.SYSTEM);

			BufferedReader reader = new BufferedReader(new InputStreamReader(pr1.getInputStream()));
			String line;
			while((line = reader.readLine())!=null) {
				Logger.writeln(line, Logger.SYSTEM);
			}
			reader.close();

			Process pr2 = pb2.start();

			Logger.writeln("Extract old code clone.", Logger.SYSTEM);
			Logger.printlnConsole("Extract old code clone.", Logger.SYSTEM);

			reader = new BufferedReader(new InputStreamReader(pr2.getInputStream()));
			while((line = reader.readLine())!=null) {
				Logger.writeln(line, Logger.SYSTEM);
			}
			reader.close();

		} catch (IOException e) {
			return false;
		}

		// ss̔
		File nf = new File(Def.RESULT_TXT);
		File of = new File(Def.RESULT_TXT_OLD);

		// t@C݂Ȃ
		if(!nf.exists() || !of.exists()) {
			Logger.writeln("Can't find result file.", Logger.ERROR);
			return false;
		}

		// t@C
		if(nf.length() == 0 || of.length() == 0) {
			Logger.writeln("Result file is empty.", Logger.ERROR);
			return false;
		}
		return true;
	}

	/**
	 * <p>Clone Detectorɂďo͂ꂽN[f[^t@C̓Ǎ</p>
	 * @return <ul>
	 *           <li>̏ꍇ - true</li>
	 *           <li>s̏ꍇ - false</li>
	 *         </ul>
	 */
	public boolean readCloneDataFile() {
		BufferedReader readFile = null;
		ArrayList<SourceFile> fileList = new ArrayList<SourceFile>();
		ArrayList<CloneSet> cloneSetList = new ArrayList<CloneSet>();
		ArrayList<String> newFileList = new ArrayList<String>();
    	ArrayList<String> oldFileList = new ArrayList<String>();

    	Logger.writeln("Read clone data file.", Logger.SYSTEM);

		try {

			// t@CXgċAIɎ擾
			if(project.getLang().equals("java")) {
				newFileList = getFileList(project.getNewDir(), true);
				oldFileList = getFileList(project.getOldDir(), true);
			} else if (project.getLang().equals("c")) {
				newFileList = getFileList(project.getNewDir(), false);
				oldFileList = getFileList(project.getOldDir(), false);
			} else {
				Logger.writeln("Invalid programming langage.", Logger.FATAL);
				return false;
			}

			Logger.writeln("Get source file status.", Logger.INFO);
			Logger.writeln("\t Analyze add & stay files.", Logger.DEBUG);

			// \[Xt@C̎擾
			Iterator<String> it = newFileList.iterator();
			int fileId = 0;
			while(it.hasNext()) {
				String fileName = it.next();
				SourceFile file = new SourceFile();
				file.setName(fileName);
				file.setNewPath(project.getNewDir() + "\\" + fileName);
				file.setOldPath(project.getOldDir() + "\\" + fileName);
				file.setId(fileId++);

				// t@CXgɊ܂܂Ȃt@C͐VKǉ
				int index = oldFileList.indexOf(fileName);
				if(index > -1) {
					file.setState(SourceFile.NORMAL);
					oldFileList.remove(fileName);
				} else {
					file.setState(SourceFile.ADDED);
				}
				fileList.add(file);
			}

			Logger.writeln("\t Analyze delete files.", Logger.DEBUG);

			// ct@C͕ύXɏ
			it = oldFileList.iterator();
			while(it.hasNext()) {
				String fileName = it.next();
				SourceFile file = new SourceFile();
				file.setName(fileName);
				file.setOldPath(project.getOldDir() + "\\" + fileName);
				file.setId(fileId++);
				file.setState(SourceFile.DELETED);
				fileList.add(file);
			}

			Logger.writeln("<Success> Get source file status.", Logger.INFO);

			if(project.getLang().equals("java")) {
				Logger.writeln("Analyze new clone result file.", Logger.INFO);
				analyzeResultFileForJava(Def.RESULT_TXT, cloneSetList, fileList, true);

				Logger.writeln("Analyze old clone result file.", Logger.INFO);
				analyzeResultFileForJava(Def.RESULT_TXT_OLD, cloneSetList, fileList, false);
			} else {
				analyzeResultFileForC(Def.RESULT_TXT, cloneSetList, fileList, true);
				analyzeResultFileForC(Def.RESULT_TXT_OLD, cloneSetList, fileList, false);
			}
	    } catch (FileNotFoundException e) {
	    	Logger.writeln("Can't found read clone file.", Logger.ERROR);
			return false;
		} catch (IOException e) {
			Logger.writeln("<IOException> Can't read clone file.", Logger.ERROR);
			return false;
		} finally {
			if(readFile != null) {
				try {
					readFile.close();
				}catch (IOException e) {
					Logger.writeln("<IOException> Can't close buffer.", Logger.ERROR);
				}
			}
		}

		Logger.writeln("Check error detection.", Logger.INFO);

		// 댟ȍ
		// XXX CloneDetectorȂsvȉ\
		@SuppressWarnings("unchecked")
		ArrayList<CloneSet> tmpCloneSetList = (ArrayList<CloneSet>)cloneSetList.clone();
		for(CloneSet cloneSet : tmpCloneSetList) {
			if(cloneSet.getNewCloneList().size() == 1) {
				cloneSet.getNewCloneList().remove(0);
			}

			if(cloneSet.getOldCloneList().size() == 1) {
				cloneSet.getOldCloneList().remove(0);
			}

			if(cloneSet.getNewCloneList().isEmpty() && cloneSet.getOldCloneList().isEmpty()) {
				cloneSetList.remove(cloneSet);
			}
		}

		// \[Xt@CɃN[̒ǉ
		for(CloneSet cloneSet : cloneSetList) {
			for(Clone clone : cloneSet.getNewCloneList()) {
				clone.getFile().getNewCloneList().add(clone);
			}

			for(Clone clone : cloneSet.getOldCloneList()) {
				clone.getFile().getOldCloneList().add(clone);
			}
		}

		// N[Xg̐
		for(SourceFile file : fileList) {
			file.sortCloneListbyMethod();
		}

		project.getCloneSetList().addAll(cloneSetList);
		project.getFileList().addAll(fileList);

		Logger.writeln("<Success> Read clone data file.", Logger.INFO);

		return true;
	}

	/**
	 * o̓t@C̉ (Javap)
	 * @param result o̓t@C̃pX
	 * @param cloneSetList ͌ʂ~郊Xg
	 * @param fileList N[܂ SourceFile ̒TpXg
	 * @param isNew VvWFNgɊւĂȂ ture
	 * @return :true, s:false
	 */
	private void analyzeResultFileForJava(String result, ArrayList<CloneSet> cloneSetList, ArrayList<SourceFile> fileList, boolean isNew) throws IOException {
		BufferedReader readFile = new BufferedReader(new FileReader(result));
		int cloneId = 0;
		CloneSet cloneSet = null;
		CloneSet tmpCloneSet = null;
		Clone clone = null;
		String methodName = null;
		String modifiedMethodName = null;
		String line;

		while((line = readFile.readLine()) != null) {

			// N[Zbg
			// clone == null ̓R[h̕Ɍ딚̂h
			if(line.startsWith("cloneset:") && clone == null) {
				int id = Integer.valueOf(line.substring("cloneset:".length()));

				// CloneSetIuWFNg̗p
				cloneSet = null;
				tmpCloneSet = new CloneSet();
				tmpCloneSet.setId(id);
			}

			// N[t@C
			if(line.startsWith("filename : ") && clone == null) {
				clone = new Clone();
				clone.setId(cloneId++);

				// ŌɕtĂ锼pXy[X̔r
				Path path = new File(line.substring("filename : ".length(), line.length()-1)).toPath();
				String abstPath = path.toAbsolutePath().toString();
				String relPath;

				if(isNew) {
					relPath = abstPath.substring(new File(project.getNewDir()).getAbsolutePath().length()+1);
				} else {
					relPath = abstPath.substring(new File(project.getOldDir()).getAbsolutePath().length()+1);
				}
				SourceFile sfile = Project.getFileObj(fileList, relPath);

				Logger.writeln("Start extracting method '" + relPath + "'.", Logger.DEBUG);
				Logger.writeln("SourceFile is " + (sfile != null ? sfile.getName() : "null"), Logger.DEBUG);
				Logger.writeln("NewFlag is " + isNew, Logger.DEBUG);

				// t@C̃\bho
				extractMethodForJava(sfile, abstPath, isNew);

				clone.setFile(sfile);
			}

			// N[ƂȂĂ郁\bh̎擾
			if(line.startsWith("methodname : ") && clone != null && methodName == null) {
				String[] mname = line.substring("methodname : ".length(), line.indexOf("(")-1).split("\\.");

				methodName = mname[mname.length-1];
				modifiedMethodName = line.substring("methodname : ".length(), line.indexOf("(")-1);
			}

			// \bh錾̒T
			if(methodName != null && line.contains(methodName + "(") && line.endsWith("{")) {
				String paramStart = methodName + "(";
				String paramPart = line.substring(line.indexOf(paramStart) + paramStart.length(), line.lastIndexOf(")"));

				clone.setMethodName(modifiedMethodName + "(" + paramPart + ")");

				Method parentMd = clone.getFile().getMethod(modifiedMethodName, methodName, paramPart, isNew, true);

				Logger.writeln("<CloneDetectorController.analyzeResultFileForJava> success: get Method.", Logger.DEBUG);

				if(parentMd == null) {
					Logger.writeln("Can't find method belonging clone.\n\tMethod name <" + clone.getMethodName() + ">.", Logger.FATAL);

					if(isNew) {
						ArrayList<Method> mdlist = isNew ? clone.getFile().getNewMethodList() : clone.getFile().getOldMethodList();
						Iterator<Method> itmd = mdlist.iterator();
						while(itmd.hasNext()) {
							Method md = itmd.next();
							Logger.writeln(md.getModifiedName() + md.getParams(), Logger.SYSTEM);
						}
					}
				} else {
					clone.setStartLine(parentMd.getStartLine());
					clone.setStartColumn(parentMd.getStartColumn());
					clone.setEndLine(parentMd.getEndLine());
					clone.setEndColumn(parentMd.getEndColumn());
				}

				Logger.writeln("<CloneDetectorController.analyzeResultFileForJava> clone.getMethodName() is " + clone.getMethodName(), Logger.DEBUG);
				Logger.writeln("<CloneDetectorController.analyzeResultFileForJava> parentMd.getName() is " + parentMd.getName(), Logger.DEBUG);

				// N[Zbg̒T͕Kv̓s, ɑ}
				// Xg瓯̃N[ZbgT
				if(cloneSet == null) {
					for(CloneSet pCloneSet : cloneSetList) {
						if(pCloneSet.equalsForCloneDetector(clone.getMethodName(), clone.getFile().getName())) {
							cloneSet = pCloneSet;
						}
					}

					if(cloneSet == null) {
						cloneSet = new CloneSet();
						cloneSetList.add(cloneSet);
					}

					// N[Zbg̈ړ
					if(isNew) {
						cloneSet.setId(tmpCloneSet.getId());
					} else {
						cloneSet.setOldId(tmpCloneSet.getId());
					}
				}

				clone.setCloneSet(cloneSet);

				// ɓo^ς݂̃N[Ȃ ID ߂
				if(isNew) {
					Logger.writeln("<CloneDetectorController.analyzeResultFileForJava> clone.getFile().getName() is " + clone.getFile().getName(), Logger.DEBUG);
					Logger.writeln("<CloneDetectorController.analyzeResultFileForJava> clone.getMethodName() is " + clone.getMethodName(), Logger.DEBUG);

					if(!addClone(cloneSet.getNewCloneList(), clone)) {
						cloneId--;
					}
				} else {
					if(!addClone(cloneSet.getOldCloneList(), clone)) {
						cloneId--;
					}
				}

				//clone.getFile().clearMethodList();

				clone = null;
				methodName = null;
			}
		}
		readFile.close();
	}

	/**
	 * o̓t@C̉ (Cp)
	 * @param result o̓t@C̃pX
	 * @param cloneSetList ͌ʂ~郊Xg
	 * @param fileList N[܂ SourceFile ̒TpXg
	 * @param isNew VvWFNgɊւĂȂ ture
	 * @return :true, s:false
	 */
	private void analyzeResultFileForC(String result, ArrayList<CloneSet> cloneSetList, ArrayList<SourceFile> fileList, boolean isNew) throws IOException {
		BufferedReader readFile = new BufferedReader(new FileReader(result));
		int cloneId = 0;
		CloneSet cloneSet = null;
		CloneSet tmpCloneSet = null;
		Clone clone = null;
		String line;

		while((line = readFile.readLine()) != null) {

			// N[̐擪
			if(line.startsWith("=================================================")) {
				cloneSet = null;
				tmpCloneSet = null;
				clone = null;
			}

			// N[ZbgID
			if(line.startsWith("cloneset:") && tmpCloneSet == null) {

				//System.err.println(line);

				int id = Integer.valueOf(line.substring("cloneset:".length()));

				// CloneSetIuWFNg̗p
				tmpCloneSet = new CloneSet();
				tmpCloneSet.setId(id);
			}

			if(line.startsWith("\t ") && tmpCloneSet != null) {
				clone = new Clone();
				clone.setId(cloneId++);

				// tH[}bg: <\t methodname @ path\...\xxx.c ( size:00 )\n>
				// [0]="\t", [1]=\bh, [2]="@", [3]=t@CpX, [4]="("
				// [5]="size:00", [6]=")"
				String[] str = line.split(" ");

				// t@C擾
				Path path = new File(str[3]).toPath();
				String abstPath = path.toAbsolutePath().toString();
				String relPath;

				if(isNew) {
					relPath = abstPath.substring(new File(project.getNewDir()).getAbsolutePath().length()+1);
				} else {
					relPath = abstPath.substring(new File(project.getOldDir()).getAbsolutePath().length()+1);
				}

				SourceFile sfile = Project.getFileObj(fileList, relPath);

				Logger.writeln("SourceFile is " + (sfile != null ? sfile.getName() : "null"), Logger.DEBUG);
				Logger.writeln("relPath is " + relPath, Logger.DEBUG);

				extractMethodForC(sfile, abstPath, isNew);

				clone.setFile(sfile);
				clone.setMethodName(str[1]);

				Method parentMd = clone.getFile().getMethod(path.getFileName().toString(), str[1], null, isNew, false);
				if(parentMd == null) {
					Logger.writeln("Can't find method belonging clone.", Logger.FATAL);
					Logger.writeln("Method name is " + clone.getMethodName(), Logger.DEBUG);
					Logger.writeln("path.getFileName().toString() is " + path.getFileName().toString(), Logger.DEBUG);
					Logger.writeln("str[1] is " + str[1], Logger.DEBUG);
				} else {
					clone.setStartLine(parentMd.getStartLine());
					clone.setStartColumn(parentMd.getStartColumn());
					clone.setEndLine(parentMd.getEndLine());
					clone.setEndColumn(parentMd.getEndColumn());
				}

				// N[Zbg̒T͕Kv̓s, ɑ}
				// Xg瓯̃N[ZbgT
				if(cloneSet == null) {
					for(CloneSet pCloneSet : cloneSetList) {
						if(pCloneSet.equalsForCloneDetector(clone.getMethodName(), clone.getFile().getName())) {
							cloneSet = pCloneSet;
						}
					}

					if(cloneSet == null) {
						cloneSet = new CloneSet();
						cloneSetList.add(cloneSet);
					}

					// N[Zbg̈ړ
					if(isNew) {
						cloneSet.setId(tmpCloneSet.getId());
					} else {
						cloneSet.setOldId(tmpCloneSet.getId());
					}
				}

				clone.setCloneSet(cloneSet);

				// ɓo^ς݂̃N[Ȃ ID ߂
				if(isNew) {
					if(!addClone(cloneSet.getNewCloneList(), clone)) {
						cloneId--;
					}
				} else {
					if(!addClone(cloneSet.getOldCloneList(), clone)) {
						cloneId--;
					}
				}
			}
		}
		readFile.close();
	}

	/**
	 * wfBNg[gƂ,
	 * ċAIɌt@CXgԂ
	 * @param root
	 * @param javaMode trueȂ".java", ȊOȂ".c", ".h"
	 * @return
	 * @throws IOException
	 */
	public ArrayList<String> getFileList(String root, boolean javaMode) throws IOException {
		File rootFile = new File(root);

		// java [h
		if(javaMode) {
			JavaFileVistor jfv = new JavaFileVistor(rootFile.getAbsolutePath());
			Files.walkFileTree(rootFile.toPath(), jfv);

			return jfv.getFileList();
		} else {
			CFileVistor cfv = new CFileVistor(rootFile.getAbsolutePath());
			Files.walkFileTree(rootFile.toPath(), cfv);

			return cfv.getFileList();
		}
	}

	/**
	 * <p>N[XgɃN[ǉ</p>
	 * @param cloneList N[Xg
	 * @param clone ǉN[
	 * @return <ul>
	 *           <li>̏ꍇ - true</li>
	 *           <li>s̏ꍇ - false</li>
	 *         </ul>
	 */
	private boolean addClone(ArrayList<Clone> cloneList, Clone clone) {
		for(Clone pClone : cloneList) {
			if(clone.equals(pClone)) {
				return false;
			}
		}
		cloneList.add(clone);
		return true;
	}



	/**
	 * \[Xt@C̃\bh𒊏o.
	 * @param sfile L^SourceFile
	 * @param abstPath Ώۃt@C̐΃pX
	 * @param isNew Vt@Ĉǂ炩
	 * @throws IOException
	 * @throws FileNotFoundException
	 */
	private void extractMethodForJava(SourceFile sfile, String abstPath, boolean isNew) throws FileNotFoundException, IOException {

		Logger.writeln("<extractMethodForJava> SouceFile is " + sfile.getName(), Logger.DEBUG);

		// ɒoς݂ȂI
		if(isNew) {
			if(sfile.getNewMethodList().size() > 0) {
				return;
			}
		} else {
			if(sfile.getOldMethodList().size() > 0) {
				return;
			}
		}

		Logger.writeln("Start extract method for " + sfile.getName(), Logger.DEBUG);

		JavaMethodExtractor jme = new JavaMethodExtractor(abstPath);

		if(isNew) {
			sfile.setNewMethodList(jme.extractMethod());
		} else {
			sfile.setOldMethodList(jme.extractMethod());
		}
	}


	/**
	 * \[Xt@C̃\bh𒊏o.
	 * @param sfile L^SourceFile
	 * @param abstPath Ώۃt@C̐΃pX
	 * @param isNew Vt@Ĉǂ炩
	 * @throws IOException
	 * @throws FileNotFoundException
	 */
	private void extractMethodForC(SourceFile sfile, String abstPath, boolean isNew) throws FileNotFoundException, IOException {

		Logger.writeln("<extractMethodForC> SouceFile is " + sfile.getName(), Logger.DEBUG);

		// ɒoς݂ȂI
		if(isNew) {
			if(sfile.getNewMethodList().size() > 0) {
				return;
			}
		} else {
			if(sfile.getOldMethodList().size() > 0) {
				return;
			}
		}

		Logger.writeln("Start extract method for " + sfile.getName(), Logger.DEBUG);

		CMethodExtractor cme = new CMethodExtractor(abstPath);

		if(isNew) {
			sfile.setNewMethodList(cme.extractMethod());
		} else {
			sfile.setOldMethodList(cme.extractMethod());
		}
	}
}
