package jp.ac.osaka_u.sel.y_yuuki.cnsetter.main;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;

/**
 * <p>GUINX</p>
 * @author y-yuuki
 */
public class Gui extends JFrame{

	private static final long serialVersionUID = 1L;

	//pl
	final JPanel mainPanel = new JPanel();
	final JPanel baseSettingPanel = new JPanel();
	final JPanel selectPanel = new JPanel();
	final JPanel csvSettingPanel = new JPanel();
	final JPanel mailSettingPanel = new JPanel();
	final JPanel webSettingPanel = new JPanel();
	//final JPanel cloneSettingPanel = new JPanel();
	final JPanel endSettingPanel = new JPanel();

	//eLXgtB[h
	final JTextField projectName = new JTextField(15);
	final JTextField checkoutCMD = new JTextField(40);
	final JTextField checkoutDir = new JTextField(35);
	final JTextField newVersion = new JTextField(35);
	final JTextField oldVersion = new JTextField(35);
	final JTextField csv = new JTextField(35);
	final JTextField text = new JTextField(35);
	final JTextField html = new JTextField(35);
	final JTextField accountFile = new JTextField(35);
	final JTextField keyFile = new JTextField(35);
	final JTextField host = new JTextField(25);
	final JTextField port = new JTextField(10);
	final JTextField from = new JTextField(30);
	final JTextField to1 = new JTextField(30);
	final JTextField to2 = new JTextField(30);
	final JTextField to3 = new JTextField(30);
	final JTextField settingFileName = new JTextField(40);
	final JLabel message = new JLabel(" ");

	//R{{bNX
	JComboBox<String> lang = new JComboBox<String>();
	JComboBox<String> ssl = new JComboBox<String> ();
	JComboBox<String> tool = new JComboBox<String>();

	//`FbN{bNX
	final JCheckBox csvCheck = new JCheckBox("CSVt@Co͂");
	final JCheckBox webCheck = new JCheckBox("EFuUI̍XVs");
	final JCheckBox mailCheck = new JCheckBox("dq[ɂʒms");
	final JCheckBox tokenThreshold = new JCheckBox("g[N臒lݒ肷");
	//final JCheckBox rnrFilter = new JCheckBox("RNRtB^O");
	final JCheckBox overLappingFilter = new JCheckBox("I[obsOtB^O");

	//XpCi
	final JSpinner token = new JSpinner(new SpinnerNumberModel(50,30,60,1));
	//final JSpinner rnr = new JSpinner(new SpinnerNumberModel(50,0,100,1));

	//WI{^
	final JRadioButton autoRadio = new JRadioButton("Ń`FbNAEgs",true);
	final JRadioButton manualRadio = new JRadioButton("蓮Ń`FbNAEgs");
	final ButtonGroup radioGroup = new ButtonGroup();

	//Qƃ{^
	final JButton refButton1 = new JButton("Q");
	final JButton refButton2 = new JButton("Q");
	final JButton refButton3 = new JButton("Q");
	final JButton refButton4 = new JButton("Q");
	final JButton refButton5 = new JButton("Q");
	final JButton refButton6 = new JButton("Q");
	final JButton refButton7 = new JButton("Q");
	final JButton refButton8 = new JButton("Q");
	final JButton refButton9 = new JButton("Q");
	final JButton generateButton = new JButton("ݒI");

	//t@CIfBNg
	final JFileChooser chooser = new JFileChooser();


	private final static String CCFX_NAME = "CCFinderX";


	/**
	 * CCFinderX pȂ trueAClone Detector pȂ false
	 * @param isCCFX
	 */
	private void changeLangComboBox(boolean isCCFX) {
		lang.removeAllItems();
		if(isCCFX) {
			lang.addItem("java");
			lang.addItem("cpp");
			lang.addItem("cobol");
			lang.addItem("csharp");
			lang.addItem("visualbasic");
			lang.addItem("plaintext");
		} else {
			lang.addItem("java");
			lang.addItem("c");
		}
	}

	/**
	 * <p>RXgN^</p>
	 */
	public Gui(){

		//
		newVersion.setEditable(false);
		oldVersion.setEditable(false);
		text.setEditable(false);
		html.setEditable(false);
		csv.setEditable(false);
		accountFile.setEditable(false);
		keyFile.setEditable(false);
		host.setEditable(false);
		port.setEditable(false);
		from.setEditable(false);
		to1.setEditable(false);
		to2.setEditable(false);
		to3.setEditable(false);
		ssl.setEnabled(false);
		token.setEnabled(false);
		//rnr.setEnabled(false);
		refButton1.setEnabled(false);
		refButton2.setEnabled(false);
		refButton3.setEnabled(false);
		refButton4.setEnabled(false);
		refButton5.setEnabled(false);
		refButton6.setEnabled(false);
		refButton7.setEnabled(false);

		//WI{^ݒ
		radioGroup.add(autoRadio);
		radioGroup.add(manualRadio);

		//R{{bNXݒ
		changeLangComboBox(false);

		tool.addItem("CloneDetector");
		//tool.addItem(CCFX_NAME);

		//SSLR{{bNXݒ
		ssl.addItem("wȂ");
		ssl.addItem("SSL/TLS");
		ssl.addItem("STARTTLS");

		//Qƃ{^1
		refButton1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if( chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					newVersion.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^2
		refButton2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					oldVersion.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^3
		refButton3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					html.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^4
		refButton4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					csv.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^5
		refButton5.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					text.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^6
		refButton6.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					accountFile.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^7
		refButton7.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					keyFile.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^8
		refButton8.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					settingFileName.setText(chooser.getSelectedFile().toString());
			}
		});

		//Qƃ{^9
		refButton9.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if(chooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION)
					checkoutDir.setText(chooser.getSelectedFile().toString());
				}
			});

		//`FbNAEg{^ݒ
		autoRadio.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				checkoutCMD.setEditable(autoRadio.isSelected());
				checkoutDir.setEditable(autoRadio.isSelected());
				oldVersion.setEditable(!autoRadio.isSelected());
				newVersion.setEditable(!autoRadio.isSelected());
				refButton1.setEnabled(!autoRadio.isSelected());
				refButton2.setEnabled(!autoRadio.isSelected());
				refButton9.setEnabled(autoRadio.isSelected());
			}
		});

		//蓮`FbNAEg{^ݒ
		manualRadio.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				checkoutCMD.setEditable(!manualRadio.isSelected());
				checkoutDir.setEditable(!manualRadio.isSelected());
				oldVersion.setEditable(manualRadio.isSelected());
				newVersion.setEditable(manualRadio.isSelected());
				refButton1.setEnabled(manualRadio.isSelected());
				refButton2.setEnabled(manualRadio.isSelected());
				refButton9.setEnabled(!manualRadio.isSelected());
			}
		});

		//g[N臒l`FbNAEg{^ݒ
		token.setPreferredSize(new Dimension(40,20));
		tokenThreshold.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				token.setEnabled(tokenThreshold.isSelected());
			}
		});

		//RNR`FbNAEg{^ݒ
		//_rnr.setPreferredSize(new Dimension(40,20));
		//_rnrFilter.addActionListener(new ActionListener() {
		//	public void actionPerformed(ActionEvent e) {
		//		_rnr.setEnabled(_rnrFilter.isSelected());
		//	}
		//});

		//EFu`FbN{bNXݒ
		webCheck.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				html.setEditable(webCheck.isSelected());
				refButton3.setEnabled(webCheck.isSelected());
			}
		});

		//CSV`FbN{bNXݒ
		csvCheck.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				csv.setEditable(csvCheck.isSelected());
				refButton4.setEnabled(csvCheck.isSelected());
			}
		});

		//dq[`FbN{bNXݒ
		mailCheck.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				text.setEditable(mailCheck.isSelected());
				accountFile.setEditable(mailCheck.isSelected());
				keyFile.setEditable(mailCheck.isSelected());
				host.setEditable(mailCheck.isSelected());
				port.setEditable(mailCheck.isSelected());
				from.setEditable(mailCheck.isSelected());
				to1.setEditable(mailCheck.isSelected());
				to2.setEditable(mailCheck.isSelected());
				to3.setEditable(mailCheck.isSelected());
				ssl.setEnabled(mailCheck.isSelected());
				refButton5.setEnabled(mailCheck.isSelected());
				refButton6.setEnabled(mailCheck.isSelected());
				refButton7.setEnabled(mailCheck.isSelected());
			}
		});

		// c[R{{bNXݒ
		tool.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent e) {
				String toolName = (String)e.getItem();
				if(toolName.equals(CCFX_NAME)) {
					changeLangComboBox(true);
				} else {
					changeLangComboBox(false);
				}
			}
		});

		//t[
		setTitle("ݒc[");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLocationRelativeTo(null);
		setResizable(false);
		GridBagConstraints c = new GridBagConstraints();
		//c.weightx=1.5;
		c.anchor = GridBagConstraints.WEST;

		/*
		 * {ݒpl
		 */
		baseSettingPanel.setBorder(BorderFactory.createTitledBorder("{ݒ"));
		baseSettingPanel.setLayout(new GridBagLayout());
		c.gridy=0; c.gridx=0; baseSettingPanel.add(new JLabel("vWFNg:"),c);
		c.gridy=0; c.gridx=1; baseSettingPanel.add(projectName,c);

		c.gridy=1; c.gridx=0; baseSettingPanel.add(new JLabel("c[:"),c);
		c.gridy=1; c.gridx=1; baseSettingPanel.add(tool,c);

		c.gridy=2; c.gridx=0; baseSettingPanel.add(new JLabel(":"),c);
		c.gridy=2; c.gridx=1; baseSettingPanel.add(lang,c);
		c.gridy=3; c.gridx=0; baseSettingPanel.add(autoRadio,c);
		c.gridy=4; c.gridx=0; baseSettingPanel.add(new JLabel("`FbNAEgR}h:"),c);
		c.gridy=4; c.gridx=1; baseSettingPanel.add(checkoutCMD,c);
		c.gridy=5; c.gridx=0; baseSettingPanel.add(new JLabel("`FbNAEgfBNg:"),c);
		c.gridy=5; c.gridx=1; baseSettingPanel.add(checkoutDir,c);
		c.gridy=5; c.gridx=2; baseSettingPanel.add(refButton8,c);
		c.gridy=6; c.gridx=0; baseSettingPanel.add(manualRadio,c);
		c.gridy=7; c.gridx=0; baseSettingPanel.add(new JLabel("ŐVo[WfBNg:"),c);
		c.gridy=7; c.gridx=1; baseSettingPanel.add(newVersion,c);
		c.gridy=7; c.gridx=2; baseSettingPanel.add(refButton1,c);
		c.gridy=8; c.gridx=0; baseSettingPanel.add(new JLabel("o[WfBNg:"),c);
		c.gridy=8; c.gridx=1; baseSettingPanel.add(oldVersion,c);
		c.gridy=8; c.gridx=2; baseSettingPanel.add(refButton2,c);
		c.gridy=9; c.gridx=0; baseSettingPanel.add(tokenThreshold,c);
		c.gridy=9; c.gridx=1; baseSettingPanel.add(token,c);
		c.gridy=10; c.gridx=0; baseSettingPanel.add(overLappingFilter,c);

		/*
		 * N[ݒpl
		 */
		//cloneSettingPanel.setBorder(new TitledBorder("R[hN[ݒ"));
		//cloneSettingPanel.setLayout((new GridBagLayout()));
		//c.gridx=0;c.gridy=0; cloneSettingPanel.add(tokenThreshold,c);
		//c.gridx=0;c.gridy=1; _cloneSettingPanel.add(_rnrFilter,c);
		//c.gridx=0;c.gridy=1; cloneSettingPanel.add(overLappingFilter,c);
		//c.gridx=1;c.gridy=0; cloneSettingPanel.add(token,c);
		//c.gridx=1;c.gridy=1; _cloneSettingPanel.add(_rnr,c);


		/*
		 * Ipl
		 */
		selectPanel.setBorder(BorderFactory.createTitledBorder("o͑I"));
		selectPanel.setLayout(new GridBagLayout());
		c.gridy=0; c.gridx=0; selectPanel.add(webCheck,c);
		c.gridy=1; c.gridx=0; selectPanel.add(webSettingPanel,c);
		c.gridy=2; c.gridx=0; selectPanel.add(csvCheck,c);
		c.gridy=3; c.gridx=0; selectPanel.add(csvSettingPanel,c);
		c.gridy=4; c.gridx=0; selectPanel.add(mailCheck,c);
		c.gridy=5; c.gridx=0; selectPanel.add(mailSettingPanel,c);


		/*
		 * EFuݒfBNg
		 */
		webSettingPanel.setBorder(BorderFactory.createTitledBorder("EFuC^tF[Xݒ"));
		webSettingPanel.setLayout(new GridBagLayout());
		c.gridx=0; c.gridy=0; webSettingPanel.add(new JLabel("HTMLo͐fBNgF"),c);
		c.gridx=1; c.gridy=0; webSettingPanel.add(html,c);
		c.gridx=2; c.gridy=0; webSettingPanel.add(refButton3,c);

		/*
		 * CSVݒfBNg
		 */
		csvSettingPanel.setBorder(BorderFactory.createTitledBorder("CSVo̓t@Cݒ"));
		csvSettingPanel.setLayout(new GridBagLayout());
		c.gridx=0; c.gridy=0; csvSettingPanel.add(new JLabel("CSVo͐fBNgF"),c);
		c.gridx=1; c.gridy=0; csvSettingPanel.add(csv,c);
		c.gridx=2; c.gridy=0; csvSettingPanel.add(refButton4,c);

		/*
		 * dq[ݒpl
		 */
		mailSettingPanel.setBorder(new TitledBorder("dq[ݒ"));
		mailSettingPanel.setLayout((new GridBagLayout()));
		c.gridx=0; c.gridy=0; mailSettingPanel.add(new JLabel("eLXgo͐fBNgF",SwingConstants.LEFT),c);
		c.gridx=0; c.gridy=1; mailSettingPanel.add(new JLabel("AJEgt@CF",SwingConstants.LEFT),c);
		c.gridx=0; c.gridy=2; mailSettingPanel.add(new JLabel("L[t@CF"),c);
		c.gridx=0; c.gridy=3; mailSettingPanel.add(new JLabel("SMTPT[ozXgF"),c);
		c.gridx=0; c.gridy=4; mailSettingPanel.add(new JLabel("|[gԍF"),c);
		c.gridx=0; c.gridy=5; mailSettingPanel.add(new JLabel("[MF"),c);
		c.gridx=0; c.gridy=6; mailSettingPanel.add(new JLabel("[M1F"),c);
		c.gridx=0; c.gridy=7; mailSettingPanel.add(new JLabel("[M2F"),c);
		c.gridx=0; c.gridy=8; mailSettingPanel.add(new JLabel("[M3F"),c);
		c.gridx=0; c.gridy=9; mailSettingPanel.add(new JLabel("SSLF"),c);
		c.gridx=1; c.gridy=0; mailSettingPanel.add(text,c);
		c.gridx=1; c.gridy=1; mailSettingPanel.add(accountFile,c);
		c.gridx=1; c.gridy=2; mailSettingPanel.add(keyFile,c);
		c.gridx=1; c.gridy=3; mailSettingPanel.add(host,c);
		c.gridx=1; c.gridy=4; mailSettingPanel.add(port,c);
		c.gridx=1; c.gridy=5; mailSettingPanel.add(from,c);
		c.gridx=1; c.gridy=6; mailSettingPanel.add(to1,c);
		c.gridx=1; c.gridy=7; mailSettingPanel.add(to2,c);
		c.gridx=1; c.gridy=8; mailSettingPanel.add(to3,c);
		c.gridx=1; c.gridy=9; mailSettingPanel.add(ssl,c);
		c.gridx=2; c.gridy=0; mailSettingPanel.add(refButton5,c);
		c.gridx=2; c.gridy=1; mailSettingPanel.add(refButton6,c);
		c.gridx=2; c.gridy=2; mailSettingPanel.add(refButton7,c);

		/*
		 * ݒIpl
		 */
		endSettingPanel.setLayout((new GridBagLayout()));
		c.gridx=0; c.gridy=0; endSettingPanel.add(new JLabel("ݒt@CF",SwingConstants.LEFT),c);
		c.gridx=1; c.gridy=0; endSettingPanel.add(settingFileName,c);
		c.gridx=2; c.gridy=0; endSettingPanel.add(refButton8,c);

		//t[ɒǉ
		mainPanel.setLayout(new GridBagLayout());
		c.anchor = GridBagConstraints.WEST;
		c.gridx=0;c.gridy=0; mainPanel.add(baseSettingPanel,c);
		//c.gridx=0;c.gridy=1; mainPanel.add(cloneSettingPanel,c);
		c.gridx=0;c.gridy=1; mainPanel.add(selectPanel,c);
		c.anchor = GridBagConstraints.CENTER;
		c.gridx=0;c.gridy=2; mainPanel.add(endSettingPanel,c);
		c.gridx=0;c.gridy=3; mainPanel.add(message,c);
		c.gridx=0;c.gridy=4; mainPanel.add(generateButton,c);
	    Container contentPane = getContentPane();
	    contentPane.add(mainPanel, BorderLayout.WEST);
		pack();
	    setVisible(true);

	    /*
	     * ݒ芮
	     */
		generateButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {

				FileGenerator fg = new FileGenerator();
				if(!fg.init(settingFileName.getText())){ message.setText("ݒt@CɊԈႢ܂D"); return;}

				/*
				 * {ݒ
				 */
				if(!fg.write("PROJECT_NAME:",projectName.getText())){	message.setText("vWFNgsłD"); return;	}
				fg.write("TOOL:",tool.getSelectedItem().toString());
				fg.write("LANGUAGE:",lang.getSelectedItem().toString());

				//̏ꍇ
				if(autoRadio.isSelected()){
					fg.write("CHECKOUT:","AUTO");
					if(!fg.write("CHECKOUT_CMD:",checkoutCMD.getText())){ message.setText("`FbNAEgR}hsłD"); return; }
					if(!fg.write("CHECKOUT_DIR:",checkoutDir.getText())){ message.setText("`FbNAEgfBNgsłD"); return; }
				}

				//蓮̏ꍇ
				if(manualRadio.isSelected()){
					fg.write("CHECKOUT:","MANUAL");
					if(!fg.write("NEW_VERSION:",newVersion.getText())){ message.setText("ŐVo[WfBNgsłD");	 return; }
					if(!fg.write("OLD_VERSION:",oldVersion.getText())){ message.setText("o[WfBNgsłD"); return; }
				}

				/*
				 * R[hN[ݒ
				 */
				//g[Nݒ
				if(tokenThreshold.isSelected()) fg.write("TOKEN:",token.getValue().toString());
				else fg.write("TOKEN:","50");

				//RNRݒ
				//if(_rnrFilter.isSelected()) fg.write("RNR:",_rnr.getValue().toString());
				//else fg.write("RNR:","0");

				//I[obsOtB^Oݒ
				if(overLappingFilter.isSelected()) fg.write("OVERLAPPING:","true");
				else fg.write("OVERLAPPING:","false");

				/*
				 * EFuC^tF[Xݒ
				 */
				if(webCheck.isSelected()){
					fg.write("WEB:","true");
					if(!fg.write("HTML_DIR:",html.getText())){	message.setText("HTMLo͐fBNgsłD");	return;	}
				}else{
					fg.write("WEB:","false");
				}

				/*
				 * CSVݒ
				 */
				if(csvCheck.isSelected()){
					fg.write("CSV:","true");
					if(!fg.write("CSV_DIR:",csv.getText())){	message.setText("CSVo͐fBNgsłD");	return;	}
				}else{
					fg.write("CSV:","false");
				}

				/*
				 * dq[ݒ
				 */
				if(mailCheck.isSelected()){
					fg.write("MAIL:","true");
					if(!fg.write("TEXT_DIR:",text.getText())){ message.setText("eLXgo͐fBNgsłD"); return; }
					if(!fg.write("ACCOUNT_FILE:",accountFile.getText())){ message.setText("AJEgt@CsłD"); return; }
					if(!fg.write("KEY_FILE:",keyFile.getText())){ message.setText("L[t@CsłD"); return; }
					if(!fg.write("HOST:",host.getText())){ message.setText("SMTPT[ozXgsłD");	 return; }
					if(!fg.write("PORT:",port.getText())){ message.setText("|[gԍsłD"); return; }
					if(!fg.write("FROM:",from.getText())){ message.setText("[MsłD"); return;	}
					if(!fg.write("TO1:",to1.getText())){ message.setText("[M悪słD"); return; }
					if(!fg.write("TO2:",to2.getText())) fg.write("TO2:","NULL");
					if(!fg.write("TO3:",to3.getText())){ fg.write("TO3:","NULL");}
					fg.write("SSL:",ssl.getSelectedItem().toString());
				}else{
					fg.write("MAIL:","false");
				}

				message.setText("ݒt@C");
				fg.end();

			}
		});
	}
}
