
extern "C" {

typedef enum _block_type { FunctionBlock, ClassBlock, ModuleBlock }
    _Py_block_ty;

struct _symtable_entry;

struct symtable {
	const char *st_filename; 
	struct _symtable_entry *st_cur; 
	struct _symtable_entry *st_top; 
	PyObject *st_symbols;    
        PyObject *st_stack;      
	PyObject *st_global;     
	int st_nblocks;          
	PyObject *st_private;        
        int st_tmpname;          
	PyFutureFeatures *st_future; 
};

typedef struct _symtable_entry {
	PyObject_HEAD
	PyObject *ste_id;        
	PyObject *ste_symbols;   
	PyObject *ste_name;      
	PyObject *ste_varnames;  
	PyObject *ste_children;  
	_Py_block_ty ste_type;   
	int ste_unoptimized;     
	unsigned ste_nested : 1;      
	unsigned ste_free : 1;        
	unsigned ste_child_free : 1;  
	unsigned ste_generator : 1;   
	unsigned ste_varargs : 1;     
	unsigned ste_varkeywords : 1; 
	unsigned ste_returns_value : 1;  
	int ste_lineno;          
	int ste_opt_lineno;      
	int ste_tmpname;         
	struct symtable *ste_table;
} PySTEntryObject;

PyAPI_DATA(PyTypeObject) PySTEntry_Type;


PyAPI_FUNC(int) PyST_GetScope(PySTEntryObject *, PyObject *);

PyAPI_FUNC(struct symtable *) PySymtable_Build(mod_ty, const char *, 
					      PyFutureFeatures *);
PyAPI_FUNC(PySTEntryObject *) PySymtable_Lookup(struct symtable *, void *);

PyAPI_FUNC(void) PySymtable_Free(struct symtable *);











}
