












	#include <CodeFragments.h>
	#include <PEFBinaryFormat.h>








static OSStatus FSReadAtOffset(SInt16 refNum, SInt32 offset, SInt32 count, void *buffer)
	
	
	
	




	CFragConnectionID 			connID;					
	PEFContainerHeader 			containerHeader;		
	PEFLoaderInfoHeader			*loaderSection;			
	void 						*section0Base;			
	Boolean						disposeSectionPointers;	






	
	
	
	
	
	
{
	OSStatus 	err;
	UInt16 		sectionIndex;
	Boolean 	found;

	MoreAssertQ(fragToFix != nil);
	MoreAssertQ(fragToFix->locator.fileSpec != nil);
	MoreAssertQ(fragToFix->connID != nil);
	MoreAssertQ(fragToFix->loaderSection == nil);
	MoreAssertQ(fragToFix->sectionHeaders == nil);
	MoreAssertQ(fragToFix->fileRef == 0);
	
	fragToFix->disposeSectionPointers = true;
	
	
	
	
	err = FSpOpenDF(fragToFix->locator.fileSpec, fsRdPerm, &fragToFix->fileRef);
	if (err == noErr) {
		err = FSReadAtOffset(fragToFix->fileRef,
								fragToFix->locator.offset,
								sizeof(fragToFix->containerHeader),
								&fragToFix->containerHeader);
		if (err == noErr) {
			if (   fragToFix->containerHeader.tag1 != kPEFTag1
				|| fragToFix->containerHeader.tag2 != kPEFTag2
				|| fragToFix->containerHeader.architecture != kCompiledCFragArch
				|| fragToFix->containerHeader.formatVersion != kPEFVersion) {
				err = cfragFragmentFormatErr;
			}
		}
		if (err == noErr) {
			fragToFix->sectionHeaders = (PEFSectionHeader *) NewPtr(fragToFix->containerHeader.sectionCount * sizeof(PEFSectionHeader));
			err = MemError();
		}
		if (err == noErr) {
			err = FSReadAtOffset(fragToFix->fileRef,
									fragToFix->locator.offset + sizeof(fragToFix->containerHeader),
									fragToFix->containerHeader.sectionCount * sizeof(PEFSectionHeader), 
									fragToFix->sectionHeaders);
		}
		if (err == noErr) {
			sectionIndex = 0;
			found = false;
			while ( sectionIndex < fragToFix->containerHeader.sectionCount && ! found ) {
				found = (fragToFix->sectionHeaders[sectionIndex].sectionKind == kPEFLoaderSection);
				if ( ! found ) {
					sectionIndex += 1;
				}
			}
		}
		if (err == noErr && ! found) {
			err = cfragNoSectionErr;
		}
		
		
	
	
{
	UInt8 *			bytePtr;
	UInt8			byte;
	UInt32			count;
	
	bytePtr = (UInt8 *)start;
	
	
	
{
	MoreAssertQ(inOpStart != nil);
	MoreAssertQ(outCount  != nil);
	
	if (PEFPkDataCount5(*inOpStart) != 0)
	{
		
		return 1 + DecodeVCountValue(inOpStart + 1, outCount);
	}
}

static OSStatus UnpackPEFDataSection(const UInt8 * const packedData,   UInt32 packedSize,
								           UInt8 * const unpackedData, UInt32 unpackedSize)
{
	OSErr			err;
	UInt32			offset;
	UInt8			opCode;
	UInt8 *			unpackCursor;
	
	MoreAssertQ(packedData != nil);
	MoreAssertQ(unpackedData != nil);
	MoreAssertQ(unpackedSize >= packedSize);

	
	
					
					for (loopCounter = 0; loopCounter < repeatCount; loopCounter++) {
						BlockMoveData(&packedData[offset], unpackCursor, blockSize);
						unpackCursor += blockSize;
					}
					offset += blockSize;
				}
				break;
			
			case kPEFPkDataRepeatBlock:
				{
					UInt32	commonSize;
					UInt32	customSize;
					UInt32	repeatCount;
					const UInt8 *commonData;
					const UInt8 *customData;
					UInt32 loopCounter;
					
					offset += DecodeInstrCountValue(&packedData[offset], &commonSize);
					offset += DecodeVCountValue(&packedData[offset], &customSize);
					offset += DecodeVCountValue(&packedData[offset], &repeatCount);
					
					commonData = &packedData[offset];
					customData = &packedData[offset + commonSize];
					
					for (loopCounter = 0; loopCounter < repeatCount; loopCounter++) {
						BlockMoveData(commonData, unpackCursor, commonSize);
						unpackCursor += commonSize;
						BlockMoveData(customData, unpackCursor, customSize);
						unpackCursor += customSize;
						customData += customSize;
					}
					BlockMoveData(commonData, unpackCursor, commonSize);
					unpackCursor += commonSize;
					offset += (repeatCount * (commonSize + customSize)) + commonSize;
				}
				break;
			
			case kPEFPkDataRepeatZero:
				{
					UInt32	commonSize;
					UInt32	customSize;
					UInt32	repeatCount;
					const UInt8 *customData;
					UInt32 loopCounter;
					
					offset += DecodeInstrCountValue(&packedData[offset], &commonSize);
					offset += DecodeVCountValue(&packedData[offset], &customSize);
					offset += DecodeVCountValue(&packedData[offset], &repeatCount);
					
					customData = &packedData[offset];
					
					for (loopCounter = 0; loopCounter < repeatCount; loopCounter++) {
						MoreBlockZero(unpackCursor, commonSize);
						unpackCursor += commonSize;
						BlockMoveData(customData, unpackCursor, customSize);
						unpackCursor += customSize;
						customData += customSize;
					}
					MoreBlockZero(unpackCursor, commonSize);
					unpackCursor += commonSize;
					offset += repeatCount * customSize;
				}
				break;
			
			default:
				#if MORE_DEBUG
					DebugStr("\pUnpackPEFDataSection: Unexpected data opcode");
				#endif
				err = cfragFragmentCorruptErr;
				goto leaveNow;
				break;
		}
	}
	
leaveNow:
	return err;
}



struct TVector {
	void *codePtr;
	void *tocPtr;
};
typedef struct TVector TVector;

static OSStatus SetupSectionBaseAddresses(FragToFixInfo *fragToFix)
	
	
	
	
	
	
	
	
{
	OSStatus 			err;
	TVector *			relocatedExport;
	SInt32				initSection;
	UInt32				initOffset;
	PEFSectionHeader *	initSectionHeader;
	Ptr					packedDataSection;
	Ptr					unpackedDataSection;
	TVector 			originalOffsets;

	packedDataSection   = nil;
	unpackedDataSection = nil;
	
	
	
	
	
	
		MoreAssertQ( initSection < fragToFix->containerHeader.sectionCount );

		initSectionHeader = &fragToFix->sectionHeaders[initSection];
		
		
		
			
			packedDataSection = NewPtr(initSectionHeader->containerLength);
			err = MemError();

			if (err == noErr) {
				unpackedDataSection = NewPtr(initSectionHeader->unpackedLength);
				err = MemError();
			}

			
			
			if (err == noErr) {
				err = UnpackPEFDataSection( (UInt8 *) packedDataSection,   initSectionHeader->containerLength,
								            (UInt8 *) unpackedDataSection, initSectionHeader->unpackedLength);
			}
			
			
		
	
	
	if (err == noErr) {
		fragToFix->section0Base = ((char *) relocatedExport->codePtr) - (UInt32) originalOffsets.codePtr;
		fragToFix->section1Base = ((char *) relocatedExport->tocPtr)  - (UInt32) originalOffsets.tocPtr;
	}
	
	
	
	
	
	
	
{
	OSStatus 			err;
	UInt32 				librariesRemaining;
	PEFImportedLibrary 	*thisImportLibrary;
	Boolean 			found;
	
	MoreAssertQ(loaderSection != nil);
	MoreAssertQ(libraryName != nil);
	MoreAssertQ(importLibrary != nil);
	
	
	
		
		if ( ! found ) {
			thisImportLibrary += 1;
			librariesRemaining -= 1;
		}
	}
	
	if (found) {
		*importLibrary = thisImportLibrary;
		err = noErr;
	} else {
		*importLibrary = nil;
		err = cfragNoLibraryErr;
	}
	return err;
}

static OSStatus LookupSymbol(CFMLateImportLookupProc lookup, void *refCon,
							PEFLoaderInfoHeader *loaderSection,
							UInt32 symbolIndex,
							UInt32 *symbolValue)
	
	
	
	
	
	
	
	
	importSymbolTable = (UInt32 *)(((char *)(loaderSection + 1)) + (loaderSection->importedLibraryCount * sizeof(PEFImportedLibrary)));
	
	
	
	symbolStringOffset = importSymbolTable[symbolIndex];
	symbolClass = PEFImportedSymbolClass(symbolStringOffset);
	symbolIsWeak = ((symbolClass & kPEFWeakImportSymMask) != 0);
	symbolClass = symbolClass & ~kPEFWeakImportSymMask;
	symbolStringOffset = PEFImportedSymbolNameOffset(symbolStringOffset);
	
	
	
	symbolStringAddress = ((char *)loaderSection) + loaderSection->loaderStringsOffset + symbolStringOffset;
	symbolString[0] = strlen(symbolStringAddress);		
	
	
	err = lookup(symbolString, symbolClass, (void **) symbolValue, refCon);
	if (err != noErr) {
		*symbolValue = 0;
		if (symbolIsWeak) {
			err = noErr;
		}
	}
	return err;
}






struct EngineState {
	UInt32 currentReloc;		
	UInt32 *sectionBase;		
	UInt32 importIndex;			
	void  *sectionD;			


static OSStatus InitEngineState(const FragToFixInfo *fragToFix,
								UInt16 relocHeaderIndex,
								EngineState *state)
	
	
	
	
	
	
	
	
	
	

	relocHeader = (PEFLoaderRelocationHeader *) (((char *) fragToFix->loaderSection) + fragToFix->loaderSection->relocInstrOffset - relocHeaderIndex * sizeof(PEFLoaderRelocationHeader));
	
	MoreAssertQ(relocHeader->reservedA == 0);		
	
	
	
	
	
	


static UInt8 kPEFRelocBasicOpcodes[kPEFRelocBasicOpcodeRange] = { PEFMaskedBasicOpcodes };

static OSStatus RunRelocationEngine(const FragToFixInfo *fragToFix, 
										PEFImportedLibrary  *importLibrary, 
										CFMLateImportLookupProc lookup, void *refCon)
	
	
	
	
	MoreAssertQ(fragToFix->section1Base != nil);	

	
	
	totalRelocs = (fragToFix->loaderSection->loaderStringsOffset - fragToFix->loaderSection->relocInstrOffset) / sizeof(UInt16);
	
	
	
	relocInstrTable = (UInt16 *)((char *) fragToFix->loaderSection + fragToFix->loaderSection->relocInstrOffset);
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	err = noErr;
	while ( sectionsLeftToRelocate > 0 ) {
		err = InitEngineState(fragToFix, sectionsLeftToRelocate, &state);
		if (err != noErr) {
			goto leaveNow;
		}
		
		while ( state.currentReloc != state.terminatingReloc ) {
			
			MoreAssertQ( state.currentReloc < totalRelocs );

			opCode = relocInstrTable[state.currentReloc];
			switch ( PEFRelocBasicOpcode(opCode) ) {
				case kPEFRelocBySectDWithSkip:
					{
						UInt16 skipCount;
						UInt16 relocCount;
						
						skipCount = ((opCode >> 6) & 0x00FF);
						relocCount = (opCode & 0x003F);
						state.relocAddress += skipCount;
						state.relocAddress += relocCount;
					}
					break;
				case kPEFRelocBySectC:
				case kPEFRelocBySectD:
					{
						UInt16 runLength;

						runLength = (opCode & 0x01FF) + 1;
						state.relocAddress += runLength;
					}
					break;
				case kPEFRelocTVector12:
					{
						UInt16 runLength;

						runLength = (opCode & 0x01FF) + 1;
						state.relocAddress += (runLength * 3);
					}
					break;
				case kPEFRelocTVector8:
				case kPEFRelocVTable8:
					{
						UInt16 runLength;

						runLength = (opCode & 0x01FF) + 1;
						state.relocAddress += (runLength * 2);
					}
					break;
				case kPEFRelocImportRun:
					{
						UInt32 symbolValue;
						UInt16 runLength;
						
						runLength = (opCode & 0x01FF) + 1;
						while (runLength > 0) {
							if ( state.importIndex >= importLibrary->firstImportedSymbol && state.importIndex < (importLibrary->firstImportedSymbol + importLibrary->importedSymbolCount) ) {
								err = LookupSymbol(lookup, refCon, fragToFix->loaderSection, state.importIndex, &symbolValue);
								if (err != noErr) {
									goto leaveNow;
								}
								*(state.relocAddress) += symbolValue;
							}
							state.importIndex += 1;
							state.relocAddress += 1;
							runLength -= 1;
						}
					}
					break;
				case kPEFRelocSmByImport:
					{
						UInt32 symbolValue;
						UInt32 index;

						index = (opCode & 0x01FF);
						if ( index >= importLibrary->firstImportedSymbol && index < (importLibrary->firstImportedSymbol + importLibrary->importedSymbolCount) ) {
							err = LookupSymbol(lookup, refCon, fragToFix->loaderSection, index, &symbolValue);
							if (err != noErr) {
								goto leaveNow;
							}
							*(state.relocAddress) += symbolValue;
						}
						state.importIndex = index + 1;
						state.relocAddress += 1;
					}
					break;
				case kPEFRelocSmSetSectC:
					{
						UInt32 index;

						index = (opCode & 0x01FF);
						state.sectionC = GetSectionBaseAddress(fragToFix, index);
						MoreAssertQ(state.sectionC != nil);
					}
					break;
				case kPEFRelocSmSetSectD:
					{
						UInt32 index;

						index = (opCode & 0x01FF);
						state.sectionD = GetSectionBaseAddress(fragToFix, index);
						MoreAssertQ(state.sectionD != nil);
					}
					break;
				case kPEFRelocSmBySection:
					state.relocAddress += 1;
					break;
				case kPEFRelocIncrPosition:
					{
						UInt16 offset;
						
						offset = (opCode & 0x0FFF) + 1;
						((char *) state.relocAddress) += offset;
					}
					break;
				case kPEFRelocSmRepeat:
					#if MORE_DEBUG
						DebugStr("\pRunRelocationEngine: kPEFRelocSmRepeat not yet implemented");
					#endif
					err = unimpErr;
					goto leaveNow;
					break;
				case kPEFRelocSetPosition:
					{
						UInt32 offset;

						
						
						
						
						
						
						
						state.currentReloc += 1;
						index = PEFRelocLgByImportFullIndex(opCode, relocInstrTable[state.currentReloc]);
						
						if ( index >= importLibrary->firstImportedSymbol && index < (importLibrary->firstImportedSymbol + importLibrary->importedSymbolCount) ) {
							err = LookupSymbol(lookup, refCon, fragToFix->loaderSection, index, &symbolValue);
							if (err != noErr) {
								goto leaveNow;
							}
							*(state.relocAddress) += symbolValue;
						}
						state.importIndex = index + 1;
						state.relocAddress += 1;
					}
					break;
				case kPEFRelocLgRepeat:
					#if MORE_DEBUG
						DebugStr("\pRunRelocationEngine: kPEFRelocLgRepeat not yet implemented");
					#endif
					err = unimpErr;
					goto leaveNow;
					break;
				case kPEFRelocLgSetOrBySection:
					#if MORE_DEBUG
						DebugStr("\pRunRelocationEngine: kPEFRelocLgSetOrBySection not yet implemented");
					#endif
					err = unimpErr;
					goto leaveNow;
					break;
				case kPEFRelocUndefinedOpcode:
					err = cfragFragmentCorruptErr;
					goto leaveNow;
					break;
				default:
					MoreAssertQ(false);
					err = cfragFragmentCorruptErr;
					goto leaveNow;
					break;
			}
			state.currentReloc += 1;
		}
		
		sectionsLeftToRelocate -= 1;
	}

leaveNow:
	return err;
}

extern pascal OSStatus CFMLateImportCore(const CFragSystem7DiskFlatLocator *fragToFixLocator,
										CFragConnectionID fragToFixConnID,
										CFragInitFunction fragToFixInitRoutine,
										ConstStr255Param weakLinkedLibraryName,
										CFMLateImportLookupProc lookup,
										void *refCon)
	
	
	
	BlockMoveData(weakLinkedLibraryName + 1, weakLinkedLibraryNameCString, weakLinkedLibraryName[0]);
	weakLinkedLibraryNameCString[weakLinkedLibraryName[0]] = 0;

	
	
	
	
	
	
	if (err == noErr) {
		err = FindImportLibrary(fragToFix.loaderSection, weakLinkedLibraryNameCString, &importLibrary);
	}
	
	
	
	
	if (err == noErr) {
		err = RunRelocationEngine(&fragToFix, importLibrary, lookup, refCon);
	}
	
	
	

	err = FindSymbol(connIDToImport, symName, (Ptr *) symAddr, &foundSymClass);
	if (err == noErr) {
		
		
{
	MoreAssertQ(connIDToImport != nil);
	return CFMLateImportCore(fragToFixLocator, fragToFixConnID, fragToFixInitRoutine,
										weakLinkedLibraryName, FragmentLookup, connIDToImport);
}

static pascal OSStatus BundleLookup(ConstStr255Param symName, CFragSymbolClass symClass,
									void **symAddr, void *refCon)
	
{
	OSStatus 	err;
	CFBundleRef bundleToImport;
	CFStringRef symNameStr;
	
	MoreAssertQ(symName != nil);
	MoreAssertQ(symAddr != nil);
	MoreAssertQ(refCon  != nil);
	
	symNameStr = nil;
	
	bundleToImport = (CFBundleRef) refCon;
	
	
	
	
	
	
	
{
	MoreAssertQ(bundleToImport != nil);
	return CFMLateImportCore(fragToFixLocator, fragToFixConnID, fragToFixInitRoutine,
										weakLinkedLibraryName, BundleLookup, bundleToImport);
}
