




typedef struct
{
    PyObject_HEAD
    sqlite3* db;

    
    int inTransaction;

    
    int detect_types;

    
    double timeout;

    
    double timeout_started;

    
    PyObject* isolation_level;

    
    char* begin_statement;

    
    int check_same_thread;

    
    long thread_ident;

    Cache* statement_cache;

    
    PyObject* statements;

    
    int created_statements;

    PyObject* row_factory;

    
    PyObject* text_factory;

    
    PyObject* function_pinboard;

    
    PyObject* collations;

    
    PyObject* Warning;
    PyObject* Error;
    PyObject* InterfaceError;
    PyObject* DatabaseError;
    PyObject* DataError;
    PyObject* OperationalError;
    PyObject* IntegrityError;
    PyObject* InternalError;
    PyObject* ProgrammingError;
    PyObject* NotSupportedError;
} Connection;

extern PyTypeObject ConnectionType;

PyObject* connection_alloc(PyTypeObject* type, int aware);
void connection_dealloc(Connection* self);
PyObject* connection_cursor(Connection* self, PyObject* args, PyObject* kwargs);
PyObject* connection_close(Connection* self, PyObject* args);
PyObject* _connection_begin(Connection* self);
PyObject* connection_begin(Connection* self, PyObject* args);
PyObject* connection_commit(Connection* self, PyObject* args);
PyObject* connection_rollback(Connection* self, PyObject* args);
PyObject* connection_new(PyTypeObject* type, PyObject* args, PyObject* kw);
int connection_init(Connection* self, PyObject* args, PyObject* kwargs);

int check_thread(Connection* self);
int check_connection(Connection* con);

int connection_setup_types(void);

