


typedef struct
{
    PyObject_HEAD
    int member;
} Helper;

static PyMemberDef helper_members[] = {
    { "member", T_INT,  offsetof(Helper, member), READONLY,
      PyDoc_STR("A member descriptor")
    },
    { NULL }
};

static PyObject *
helper_getter(Helper *self, void *unused) 
{
    Py_RETURN_NONE;
}

static PyGetSetDef helper_getset[] = {
    { "getter", (getter)helper_getter, NULL,
      PyDoc_STR("A getset descriptor"),
    },
    { NULL }
};

static PyTypeObject HelperType = {
    PyObject_HEAD_INIT(NULL)
    0,						
    "_types.Helper",				
    sizeof(Helper),                             
    0,						
    0,						
    0,						
    0,						
    0,						
    0,						
    0,                                          
    0,                                          
    0,						
    0,						
    0,                                          
    0,              				
    0,          				
    0,                                          
    0,						
    0,						
    Py_TPFLAGS_DEFAULT,                         
    0,      					
    0,						
    0,						
    0,                                          
    0,						
    0,						
    0,						
    0,      					
    helper_members,                             
    helper_getset,                              
    0,						
    0,						
    0,						
    0,						
    0,						
    0,						
    0,						
    0,                                          
    0,						
};

PyMODINIT_FUNC
init_types(void)
{
    PyObject *m;

    m = Py_InitModule3("_types", NULL, "A types module helper");
    if (!m)
        return;

    if (PyType_Ready(&HelperType) < 0)
        return;

    Py_INCREF(&HelperType);
    PyModule_AddObject(m, "Helper", (PyObject *)&HelperType);
}

    
