
int isWinNT;


static UINT debug(MSIHANDLE hInstall, LPCSTR msg)
{
	MSIHANDLE hRec = MsiCreateRecord(1);
	if (!hRec || MsiRecordSetStringA(hRec, 1, msg) != ERROR_SUCCESS) {
		return ERROR_INSTALL_FAILURE;
	}
	MsiProcessMessage(hInstall, INSTALLMESSAGE_INFO, hRec);
	MsiCloseHandle(hRec);
	return ERROR_SUCCESS;
}


UINT __declspec(dllexport) __stdcall CheckDir(MSIHANDLE hInstall)
{
	WCHAR wpath[PSIZE];
	char path[PSIZE];
	UINT result;
	DWORD size = PSIZE;
	DWORD attributes;

	isWinNT = (GetVersion() < 0x80000000) ? 1 : 0;
	
	if (isWinNT)
		result = MsiGetPropertyW(hInstall, L"TARGETDIR", wpath, &size);
	else
		result = MsiGetPropertyA(hInstall, "TARGETDIR", path, &size);
	if (result != ERROR_SUCCESS)
		return result;
	wpath[size] = L'\0';
	path[size] = L'\0';

	if (isWinNT)
		attributes = GetFileAttributesW(wpath);
	else
		attributes = GetFileAttributesA(path);
	if (attributes == INVALID_FILE_ATTRIBUTES ||
		!(attributes & FILE_ATTRIBUTE_DIRECTORY)) 
	{
		return MsiSetPropertyA(hInstall, "TargetExists", "0");
	} else {
		return MsiSetPropertyA(hInstall, "TargetExists", "1");
	}
}


UINT __declspec(dllexport) __stdcall UpdateEditIDLE(MSIHANDLE hInstall)
{
	INSTALLSTATE ext_old, ext_new, tcl_old, tcl_new, reg_new;
	UINT result;

	result = MsiGetFeatureStateA(hInstall, "Extensions", &ext_old, &ext_new);
	if (result != ERROR_SUCCESS)
		return result;
	result = MsiGetFeatureStateA(hInstall, "TclTk", &tcl_old, &tcl_new);
	if (result != ERROR_SUCCESS)
		return result;

	
	if (ext_new == INSTALLSTATE_UNKNOWN)
		ext_new = ext_old;
	if (tcl_new == INSTALLSTATE_UNKNOWN)
		tcl_new = tcl_old;

	
